
import {
  ClassType,
} from '@overflow/commons/core/type';

import {
  Method,
} from '@overflow/commons/core/reflect';

import {
  ActionMappingAnnotation,
  ReducerAnnotation,
  RestAPIAnnotation,
  RpcAPIAnnotation,
} from '@overflow/commons/redux/decorators';

import { Class } from '@overflow/commons/core/reflect';
import { Action } from './action';

export default class DispatchReducer {

  private reducerMap: Map<string, any[]>;

  protected constructor() {
    this.reducerMap = new Map();
  }

  public reducer<State>(state: State, action: Action): State {
    // let rm: string[] = action.type.split('.');
    // if (null == rm || 2 !== rm.length) {
    //   console.log(`Method[${action.type}] is not valid.`);
    //   return null;
    // }

    // const reducerName: string = rm[0];
    // const methodName: string = rm[1];

    // if (this.reducerMap.has(reducerName)) {
    //   let reducers = this.reducerMap.get(reducerName);
    //   for (let reducer of reducers) {

    //     state = reducer(state, action);
    //   }
    // }

    return state;
  }

  /**
   * registerReducers
   */
  public registerReducers(reducerTypes: ClassType[]): void {
    for (let reducerType of reducerTypes) {
      this.registerReducer(reducerType);
    }
  }

  /**
   * registerReducer
   */
  public registerReducer(reducerType: ClassType): void {
    let clazz: Class = Class.forClass(reducerType);

    let ra: ReducerAnnotation = clazz.getOwnAnnotation(ReducerAnnotation);
    if (undefined === ra) {
      console.warn(`Class is not Reducer type. add @Reducer annotation to class[${reducerType.name}]`);
      return;
    }

    let reducerMapping: string = null;
    let ama: ActionMappingAnnotation = clazz.getOwnAnnotation(ActionMappingAnnotation);

    clazz.getOwnMethods().forEach(method => {
      let restAPIAnnotation: RestAPIAnnotation = method.getOwnAnnotation(RestAPIAnnotation);
      let rpcAPIAnnotation: RpcAPIAnnotation = method.getOwnAnnotation(RpcAPIAnnotation);
      if (restAPIAnnotation) {
        console.log(`restAPI: ${restAPIAnnotation.attributes.entryPath}`);
      }
      if (rpcAPIAnnotation) {
        console.log(`restAPI: ${rpcAPIAnnotation.attributes.method}`);
      }
    });
  }

  // protected registerReducerMethod(ama: ActionMappingAnnotation, method: Method): void {

  // }
}
